/* import only the necessary Bootstrap files */
@import "../node_modules/bootstrap/scss/functions";
@import "../node_modules/bootstrap/scss/variables";
@import "@angular/material/prebuilt-themes/indigo-pink.css";


/* -------begin customization-------- */

$theme-colors: (
  "primary":    #732eb3ff,
  "secondary":  #aaaaaaff,
  "success":    #a61fe0ff,
  "info":       #aaaaaaff,
  "warning":    #ffb71cff,
/*  "danger":     .., */
  "light":      #e5e5e5ff /*,
  "dark":       .. */
);

/* -------end customization-------- */

/* finally, import Bootstrap to set the changes! */
@import "../node_modules/bootstrap/scss/bootstrap";
@import "../node_modules/bootstrap-icons/font/bootstrap-icons.min.css";

@import '~ag-grid-community/styles/ag-grid.css';
@import '~ag-grid-community/styles/ag-theme-balham.css';
@import '~ag-grid-community/styles/ag-theme-alpine.css';
@import "app/app.component.css";
@import 'variables-main';


body {
  font-size: 12px;
}

.logo {
  width: 2.5rem !important;
  height: 2.5rem !important;
}

.hero .app-logo {
  max-width: none;
}

.mat-list-icon {
  color: rgba(0, 0, 0, 0.54);
}

.file-name-text {
  font-size: 8px !important;
  font-weight: 700 !important;
}

.banner-2 {
  color: white;
  background: var(--greywarm-dark);
  box-shadow: 2px 0px 2px var(--greycool-darkest);
  opacity: 1;
}

// This was originally applied to the "Additional" menu on the Object Explorer page.
.menu-gradient div.mat-menu-content {
  padding-bottom: 0;
}
div.mat-menu-panel.menu-gradient {
  color: var(--white-lightest);
  background: linear-gradient(180deg,var(--greywarm-darker) 30%,var(--greywarm-medium) 100%);
  box-shadow: 0px 2px 2px var(--greycool-darkest);
  border-radius: 0 0 0.3rem 0.3rem;
  padding-bottom: 0.5rem;
}
/*div.mat-menu-panel.menu-gradient:after {
  display: block;
  content: '';
  height: 1.5em;
  width: 100%;
  color: var(--white-lightest);
  background: linear-gradient(0deg,var(--greywarm-lightest) 0%,var(--grey-dark)70%);
}*/
.menu-gradient .mat-menu-item {
  height: 2em;
  line-height: 2em;
  font-family: hci-font;
  cursor: pointer;
   &:hover {
    background-color: var(--greywarm-dark) !important;
    font-weight: 700;
  }
  &:active {
    background-color: var(--bluewarmvivid-lightest) !important;
    font-weight: 700;
  }
}
button.mat-menu-item {
  color: var(--white-lightest);
}

// This is for the profile dropdown menu items on the top navbar.
ul.dropdown-menu.hci-li-dd-ul {
  padding-bottom: 0;
  color: var(--white-lightest);
  background: linear-gradient(180deg,var(--greywarm-darker) 30%,var(--greywarm-medium) 100%);
  box-shadow: 0px 2px 2px var(--greycool-darkest);
  border-radius: 0 0 0.3rem 0.3rem;
  margin-top: -0.4rem !important;
}
ul.dropdown-menu.hci-li-dd-ul .hci-li a.dropdown-item.hci-li-a {
  background: transparent;
  color: var(--white-lightest);
  font-size: 0.875rem;
  &:hover {
    background-color: var(--greywarm-dark);
    font-weight: 700;
  }
  &:active {
    background-color: var(--bluewarmvivid-lightest);
    font-weight: 700;
  }
}
/*ul.dropdown-menu.hci-li-dd-ul:after {
  display: block;
  content: '';
  height: 1.5em;
  width: 100%;
  color: var(--white-lightest);
  background: linear-gradient(0deg,var(--greywarm-lightest) 0%,var(--grey-dark)70%);
}*/

// Object Explorer's main grid.
.grid-gradient div.ag-root-wrapper-body {
  background: linear-gradient( 0deg, var(--white-lightest) 30%, var(--bluewarmvividfade-lighter) 100% ) !important;
}

// Object Explorer's main grid - makes headers' background transparent to allow the gradient to show through.
.grid-gradient div.ag-header {
  background-color: rgba(0, 0, 0, 0);
}

// Object Explorer's main grid
.grid-gradient .ag-cell, .ag-theme-alpine .ag-full-width-row .ag-cell-wrapper.ag-row-group {
  line-height: 30px;
}

// Object Explorer's main grid
.grid-gradient .ag-cell-wrapper > *:not(.ag-cell-value):not(.ag-group-value) {
  height: 30px;
}

// Swapping out expand/collapse cursors with fontawesome svgs
.grid-gradient .ag-icon-tree-open::before {
  display: block;

  height: 1rem;
  min-width: 14px;

  content: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%233d7a99' xmlns='http://www.w3.org/2000/svg'><path d='M3.204 5h9.592L8 10.481zm-.753.659 4.796 5.48a1 1 0 0 0 1.506 0l4.796-5.48c.566-.647.106-1.659-.753-1.659H3.204a1 1 0 0 0-.753 1.659'/></svg>");
}
.grid-gradient .ag-row-selected .ag-icon-tree-open::before {
  display: block;

  height: 1rem;
  min-width: 14px;

  content: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%23ffffff' xmlns='http://www.w3.org/2000/svg'><path d='M3.204 5h9.592L8 10.481zm-.753.659 4.796 5.48a1 1 0 0 0 1.506 0l4.796-5.48c.566-.647.106-1.659-.753-1.659H3.204a1 1 0 0 0-.753 1.659'/></svg>");
}

.grid-gradient .ag-icon-tree-closed::before {
  display: block;

  height: 1rem;
  min-width: 14px;

  content: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%233d7a99' xmlns='http://www.w3.org/2000/svg'><path d='m12.14 8.753-5.482 4.796c-.646.566-1.658.106-1.658-.753V3.204a1 1 0 0 1 1.659-.753l5.48 4.796a1 1 0 0 1 0 1.506z'/></svg>");
}
.grid-gradient .ag-row-selected .ag-icon-tree-closed::before {
  display: block;

  height: 1rem;
  min-width: 14px;

  content: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%23ffffff' xmlns='http://www.w3.org/2000/svg'><path d='m12.14 8.753-5.482 4.796c-.646.566-1.658.106-1.658-.753V3.204a1 1 0 0 1 1.659-.753l5.48 4.796a1 1 0 0 1 0 1.506z'/></svg>");
}
.grid-gradient .ag-row.ag-row {
  &:hover {
    background-color: var(--bluewarmvividfade-light );
    color: var(--bluewarm-darker)
  }
}
// Makes width of expand/collapse icons the same (so names do not jump around on expand/collapse).
.grid-gradient .ag-icon .ag-icon-tree-closed {
  width: 14px;
}

.grid-gradient .ag-row.custom-class-normal {
  color: var(--black-darkest);
}

.grid-gradient .custom-class-normal .svg-inline--fa.fa-fw {
  color: var(--bluewarm-dark);
}

.grid-gradient .custom-class-normal .bi {
  color: var(--bluewarm-dark);
}

.grid-gradient .custom-class-normal.ag-row.ag-row-selected .svg-inline--fa.fa-fw {
  color: white;
}
// Special Selection colors
.grid-gradient .ag-row.ag-row-selected {
  color: white;
  background-color: var(--bluewarmvivid-lightest);
  border-color: var(--bluewarmvivid-lightest);
}
.grid-gradient .ag-row.ag-row-selected.selected-secondary-color {
  background-color: var(--bluewarmvivid-lighter);
  border-color: var(--bluewarmvivid-lighter);
}
.grid-gradient .ag-row.ag-row-selected.selected-tertiary-color {
  background-color: var(--bluewarmvivid-light);
  border-color: var(--bluewarmvivid-light);
}
.grid-gradient .ag-row.ag-row-selected.selected-quaternary-color {
  background-color: var(--bluewarmvivid-medlight);
  border-color: var(--bluewarmvivid-medlight);
}
// Alternating backgrounds for items
.grid-gradient div.ag-row-even {
  background-color: var(--white-light);
}
.grid-gradient div.ag-row-odd {
  background: transparent;
}
// Making an overlay-ish style scrollbar
.grid-gradient .ag-body-viewport {
  background-color: #00000000;
  background-image: url("./assets/Grid_background_gradient.png");
  background-size: 100% 100%;
  background-repeat: no-repeat;
  background-position-x: left;
  transition: background-color 1s ease;
}
//.grid-gradient .ag-body-viewport:hover {
//  background-color: var(--greywarm-dark);
//  transition: background-color 0.4s ease;
//}

.grid-gradient .ag-body-viewport::-webkit-scrollbar {
  width: 13px;
}
.grid-gradient .ag-body-viewport::-webkit-scrollbar-track {
  background-color: #00000000;
}
.grid-gradient .ag-body-viewport::-webkit-scrollbar-thumb {
  background-color: inherit;
  border-radius: 8px;
}



.vertical-center {
  vertical-align: middle;
}

.no-padding {
  padding: 0;
}

.half-padded {
  padding: 0.15em;
}

.padded {
  padding: 0.3em;
}

.padded-left {
  padding-left: 0.3em;
}

.padded-right {
  padding-right: 0.3em;
}

.padded-top {
  padding-top: 0.3em;
}

.padded-bottom {
  padding-bottom: 0.3em;
}

.padded-left-right {
  padding-left: 0.3em;
  padding-right: 0.3em;
}

.double-padded {
  padding: 0.6em;
}

.double-padded-left {
  padding: 0.6em;
}

.double-padded-right {
  padding-right: 0.6em;
}

.double-padded-top {
  padding-top: 0.6em;
}

.double-padded-bottom {
  padding-bottom: 0.6em;
}

.double-padded-left-right {
  padding-left: 0.6em;
  padding-right: 0.6em;
}

div.angular-tree-component {
  position: absolute;
  max-height: 100%;
  overflow-y: auto;
}

tree-viewport {
  overflow: hidden !important;
}


@keyframes makeSpace {
  0% { margin-left: 200px; opacity: 0; }
  100% { margin-left: 0; opacity: 1; }
}


.tree-children {
  animation: 0.25s ease-out 0s 1 makeSpace;
}

/* width */
div.angular-tree-component::-webkit-scrollbar {
  width: 0;
  opacity: 0;
}

div.node-content-wrapper {
  padding: 2px 5px 2px 0;
}

span.toggle-children-wrapper {
  height: 100%;
  vertical-align: center;
  padding: 4px 5px 8px 10px;
}

span.toggle-children-wrapper-expanded {
  height: 100%;
  vertical-align: center;
  padding: 3px 5px 9px 10px;
}


@keyframes rotationCW {
  0% { transform: rotate(-90deg); }
  100% { transform: rotate(0deg); }
}

@-moz-keyframes rotationCW {
  0% { transform: rotate(-90deg); }
  100% { transform: rotate(0deg); }
}

@-webkit-keyframes rotationCW {
  0% { transform: rotate(-90deg); }
  100% { transform: rotate(0deg); }
}


@keyframes fadeInRotationCCW {
  0% {
    transform: rotate(90deg);
    opacity: 0.5;
  }
  100% {
    transform: rotate(0deg);
    opacity: 1;
  }
}

@-moz-keyframes rotationRight {
  0% {
    transform: rotate(90deg);
    opacity: 0.5;
  }
  100% {
    transform: rotate(0deg);
    opacity: 1;
  }
}

@-webkit-keyframes rotationRight {
  0% {
    transform: rotate(90deg);
    opacity: 0.5;
  }
  100% {
    transform: rotate(0deg);
    opacity: 1;
  }
}


span.toggle-children {
  height: 1em;
  width: 14px;
  background-image:  url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%233d7a99' xmlns='http://www.w3.org/2000/svg'><path d='m12.14 8.753-5.482 4.796c-.646.566-1.658.106-1.658-.753V3.204a1 1 0 0 1 1.659-.753l5.48 4.796a1 1 0 0 1 0 1.506z'/></svg>");
  background-repeat: no-repeat;

  animation: 0.15s linear 0s 1 fadeInRotationCCW;
  -webkit-animation: 0.15s linear 0s 1 fadeInRotationCCW;
  -moz-animation: 0.15s linear 0s 1 fadeInRotationCCW;
}

span.toggle-children-wrapper-expanded span.toggle-children {
  height: 1em;
  width: 14px;

  transform: none;

  background-image: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%233d7a99' xmlns='http://www.w3.org/2000/svg'><path d='M3.204 5h9.592L8 10.481zm-.753.659 4.796 5.48a1 1 0 0 0 1.506 0l4.796-5.48c.566-.647.106-1.659-.753-1.659H3.204a1 1 0 0 0-.753 1.659'/></svg>");
  background-repeat: no-repeat;

  animation: 0.15s linear 0s 1 rotationCW;
  -webkit-animation: 0.15s linear 0s 1 rotationCW;
  -moz-animation: 0.15s linear 0s 1 rotationCW;
}

.mat-mdc-option.mdc-list-item {
  font-family: hci-font;
  font-size: 0.8rem;
}

.mat-mdc-chip.mat-primary.mat-mdc-standard-chip span span .mat-mdc-chip-action-label{
  font-family: hci-font;
  font-size: 0.8rem;
}
.hci-combobox-container mat-form-field .mat-mdc-form-field-bottom-align{
  display: none;
}

.hci-sidebar span.toggle-children {
  height: 1em;
  width: 14px;
  background-image: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%233d7a99' xmlns='http://www.w3.org/2000/svg'><path d='m12.14 8.753-5.482 4.796c-.646.566-1.658.106-1.658-.753V3.204a1 1 0 0 1 1.659-.753l5.48 4.796a1 1 0 0 1 0 1.506z'/></svg>");
  background-repeat: no-repeat;

  animation: 0.15s linear 0s 1 fadeInRotationCCW;
  -webkit-animation: 0.15s linear 0s 1 fadeInRotationCCW;
  -moz-animation: 0.15s linear 0s 1 fadeInRotationCCW;
}

.hci-sidebar span.toggle-children-wrapper-expanded span.toggle-children {
  height: 1em;
  width: 14px;

  transform: none;

  background-image: url("data:image/svg+xml,<svg viewBox='0 0 16 16' fill='%233d7a99' xmlns='http://www.w3.org/2000/svg'><path d='M3.204 5h9.592L8 10.481zm-.753.659 4.796 5.48a1 1 0 0 0 1.506 0l4.796-5.48c.566-.647.106-1.659-.753-1.659H3.204a1 1 0 0 0-.753 1.659'/></svg>");
  background-repeat: no-repeat;

  animation: 0.15s linear 0s 1 rotationCW;
  -webkit-animation: 0.15s linear 0s 1 rotationCW;
  -moz-animation: 0.15s linear 0s 1 rotationCW;
}


div.ag-center-cols-viewport {
  overflow-x: hidden !important;
}

.navbar .nav-container .nav-link {
  padding: 0.5rem 0.5rem;
}

.cursor { cursor: pointer; }

.align-baseline {
  align-items: baseline;
}

.delete-dialog-container .mat-dialog-container,  .dynamic-standard-dialog-container .mat-dialog-container {
  background-color: var(--background);
  box-shadow: none;
  padding: 0 !important;
  overflow: hidden !important;
}

.d-flex    { display: flex; }
.flex-grow { flex-grow: 1;  }

.flex-column {
  display: flex;
  flex-direction: column;
}

.flex-row {
  display: flex;
  flex-direction: row;
}

.form-row {
  justify-content: flex-end;
  padding: .3em .1em .3em .1em;
}

.form-row > label {
  padding-right: 1em;
  flex: 1;
}

.form-row > input, .form-row > .hci-combobox-container, .form-row >  textarea {
  flex: 4;
  font-size: 0.8rem;
  height: unset;
  padding-left: 0.3em;
}
.mat-form-field .mat-form-field-wrapper .mat-form-field-flex > .mat-form-field-outline {
  background-color: white
}
///* We don't use floating label of mat-form-field */
.hci-combobox-container mat-form-field .mdc-text-field--outlined {
  overflow: hidden;
}


